import uuid

from sqlalchemy.orm import Mapped, mapped_column, relationship
from sqlalchemy.orm.properties import ForeignKey

from . import Base, str_25, uuidpk


class SubMenu(Base):
    __tablename__ = "submenu"

    id: Mapped[uuidpk]
    title: Mapped[str_25]
    description: Mapped[str | None]

    parent_menu: Mapped[uuid.UUID] = mapped_column(ForeignKey("menu.id", ondelete="CASCADE"))
    dishes: Mapped[list["Dish"]] = relationship(
        "Dish",
        backref="submenu",
        lazy="selectin",
        cascade="all, delete",
    )
